
VKEY_SETUP:
		lda	#$00
		sta	$8E		; Ch.D temp
		sta	$8F		; Ch.E temp

.vkWaitV:
		lda	$2002
		bpl	.vkWaitV

		lda	#$00
		sta	$2001
		lda	#$00
		sta	$2000

		lda	$2002

		lda	#$20
		sta	$2006
		lda	#$00
		sta	$2006
		ldx	#$04
		ldy	#$00
		lda	#$90
.vramclr:
		sta	$2007
		iny
		bne	.vramclr
		dex
		bne	.vramclr

		lda	#$23		; Attribute
		sta	$2006
		lda	#$C0
		sta	$2006
		ldx	#$40
		lda	#$00
.vramclr2:
		sta	$2007
		dex
		bne	.vramclr2

		; chr trans
		lda	#$09		; $0900-$0FFF
		sta	$2006
		lda	#$00
		sta	$2006

		lda	#LOW(CHRTBL)
		sta	$80
		lda	#HIGH(CHRTBL)
		sta	$81

		ldx	#$07
		ldy	#$00
.chrtr_010:
		lda	[$80],y
		sta	$2007
		iny
		bne	.chrtr_010
		inc	$81
		dex
		bne	.chrtr_010

		; mck title etc..
		lda	#$20
		sta	$2006
		lda	#$20
		sta	$2006
		ldx	#$00
.vramtr_010:
		lda	TITLE_STR,x
		sta	$2007
		inx
		cpx	#sizeTITLE_STR
		bne	.vramtr_010

		lda	#$20
		sta	$2006
		lda	#$80
		sta	$2006

		lda	#$9A
		sta	$80		; temp

;		ldy	#12
; for Virtual Keyboard
		ldy	#11

.vramtr_020:
		lda	#$00		; Spc
		sta	$2007
		lda	#$99		; Ch

; for Virtual Keyboard
		cpy	#9
		bcs	.vramtr_021
		lda	#$A5		; Ex
.vramtr_021:

		sta	$2007
		lda	$80		; A-C,F,P-W
		sta	$2007

		ldx	#$00
.vramtr_030:
		lda	KEYTBL,x
		sta	$2007
		inx
		cpx	#sizeKEYTBL
		bne	.vramtr_030
		inc	$80
		dey
		bne	.vramtr_020

		; palette
		lda	#$3F
		sta	$2006
		lda	#$00
		sta	$2006
		ldx	#$00
.paltr_010:
		lda	PALTBL,x
		sta	$2007
		inx
		cpx	#sizePALTBL
		bne	.paltr_010

		; sprite clr
		ldx	#$00
		lda	#$F8
.sprclr:
		sta	$0700,x
		inx
		bne	.sprclr

		; level gauge sprite setup
		; Ch.D
		; y pos
		lda	#12-1
		sta	$0740
		sta	$0744
		sta	$0748

		; attribute
		lda	#%01000000	; H FLIP
		sta	$0742
		sta	$0746
		sta	$074A

		; x pos
		lda	#23+8*0
		sta	$0743
		lda	#23+8*1
		sta	$0747
		lda	#23+8*2
		sta	$074B

		; Ch.E
		; y pos
		lda	#12-1
		sta	$074C
		sta	$0750
		sta	$0754

		; attribute
		lda	#%00000000
		sta	$074E
		sta	$0752
		sta	$0756

		; x pos
		lda	#224+8*0
		sta	$074F
		lda	#224+8*1
		sta	$0753
		lda	#224+8*2
		sta	$0757

		; scroll reg reset
		lda	$2002
		lda	#$00
		sta	$2005
		lda	#$00
		sta	$2005

.vwait010:
		lda	$2002
		bpl	.vwait010

;		lda	#%00011000
;		sta	$2001
;		lda	#%10100000
;		sta	$2000
		rts

; NMI^[̑Oɓ
VKEY_DISP:
		pha
		txa
		pha
		tya
		pha
		; CH A,B,C
		lda	#$00
		sta	$80		; spr addr temp

		lda	#31		; start y
		sta	$81		; spr y temp

		ldx	#$00
.VKEY_D010:
		cpx	#3*2		; Ch.D΂
		beq	.VKEY_D040
		cpx	#4*2		; Ch.E΂
		beq	.VKEY_D040

		lda	rest_flag,x	; xtO

		and	#$01
		beq	.VKEY_D020
.VKEY_D025:
		lda	#$F8		; xȂ̂Ŕ\
		ldy	$80
		sta	$0700,y
		clc
		bcc	.VKEY_D030
.VKEY_D020:
		lda	sound_sel,x	; Ch.note

		lsr	a
		lsr	a
		lsr	a
		lsr	a
		tay
		lda	KEYOFS,y
		cmp	#$FF		; \H
		beq	.VKEY_D025
		sta	$82		; x temp

		lda	sound_sel,x	; Ch.note

		and	#$0F
		tay
		lda	KEYPTN,y
		ldy	$80		; spr addr
		sta	$0701,y		; tile index

		lda	sound_sel,x	; Ch.note

		and	#$0F
		tay
		lda	KEYPOS,y
		clc
		adc	$82		; x temp
		ldy	$80		; spr addr
		sta	$0703,y		; x pos

		lda	#$00
		sta	$0702,y		; attribute
		lda	$81		; spr y pos
		sta	$0700,y
.VKEY_D030:
		inc	$80		; spr addrXV
		inc	$80
		inc	$80
		inc	$80

		lda	$81		; spr yXV
		clc
		adc	#16		; +16dot
		sta	$81
.VKEY_D040:
		inx
		inx
		cpx	#PTR_TRACK_END*2
		bne	.VKEY_D010

;
; x[^
;
; Ch.D
		lda	register_low+3*2	; \tgGx̃{[l
		clc
		adc	register_low+3*2	; 6{Ă݂
		adc	register_low+3*2
		adc	register_low+3*2
		adc	register_low+3*2
		adc	register_low+3*2

		lsr	a

		cmp	$8E
		bcc	.VKEY_D120	; 菬

		cmp	#6*4		; Limit
		bcc	.VKEY_D110
		lda	#6*4
.VKEY_D110:
		sta	$8E

; Ƃ肠jU؂悤ɒǉĂ݂
		bne	.VKEY_D200

.VKEY_D120:
; 
		lda	$8E
		beq	.VKEY_D200
		dec	$8E

.VKEY_D200:
; Ch.E
		lda	rest_flag+4*2	; xtO

		and	#$01
		beq	.VKEY_D210
; Ă
		lda	#6*4
		sta	$8F
		clc
		bcc	.VKEY_D220
.VKEY_D210:
; ĂȂ̂Ō
		lda	$8F
		beq	.VKEY_D220
		dec	$8F
.VKEY_D220:
		lda	#$00
		sta	rest_flag+4*2	; xtO

; Q[W\
		lda	$8E
		and	#$FC
		tax
		lda	LEVELGAUGE_DCH+0,x	; 1
		sta	$0741			; tile index
		lda	LEVELGAUGE_DCH+1,x	; 2
		sta	$0745			; tile index
		lda	LEVELGAUGE_DCH+2,x	; 3
		sta	$0749			; tile index

		lda	$8F
		and	#$FC
		tax
		lda	LEVELGAUGE_ECH+0,x	; 1
		sta	$074D			; tile index
		lda	LEVELGAUGE_ECH+1,x	; 2
		sta	$0751			; tile index
		lda	LEVELGAUGE_ECH+2,x	; 3
		sta	$0755			; tile index

		pla
		tay
		pla
		tax
		pla
		rts

; NMI̍ŏɓ
SPR_DMA:
		pha
		lda	#$07
		sta	$4014
		pla
		rts
;
; TABLE
;
LEVELGAUGE_DCH:
		db	$C4,$C2,$C0,$00
		db	$CA,$C8,$C6,$00
		db	$D0,$CE,$CC,$00
		db	$D6,$D4,$D2,$00
		db	$DC,$DA,$D8,$00
		db	$E2,$E0,$DE,$00
		db	$E8,$E6,$E4,$00
LEVELGAUGE_ECH:
		db	$C0,$C2,$C4,$00
		db	$C6,$C8,$CA,$00
		db	$CC,$CE,$D0,$00
		db	$D2,$D4,$D6,$00
		db	$D8,$DA,$DC,$00
		db	$DE,$E0,$E2,$00
		db	$E4,$E6,$E8,$00

; IN^[u +28dot Y=32X^[g
		;	o0 o1 o2 o3 o4  o5  o6  o7  o8 o9  o10 o11 o12 o13 o14 o15
KEYOFS:
		db	$FF,0,28,56,84,112,140,168,196,$FF,$FF,$FF,$FF,$FF,$FF,$FF
KEYPOS:
		;	+0 +1 +2 +3 +4 +5 +6 +7 +8 +9 +A +B +C +D +E +F
		db	24,26,28,30,32,36,38,40,42,44,46,48,0,44,46,48
KEYPTN:
		;	+0  +1  +2  +3  +4  +5  +6  +7  +8  +9  +A  +B  +C  +D  +E  +F
		db	$EA,$F0,$EC,$F0,$EE,$EA,$F0,$EC,$F0,$EC,$F0,$EE,0,$EC,$F0,$EE

TITLE_STR:
		db	$90,$90,$90,$B5,$B6,$B7,$90,$90,$90,$90,$90,$90,$90,$90,$90,$90
		db	$90,$90,$90,$90,$90,$90,$90,$90,$90,$90,$90,$90,$B5,$B6,$B7,$90
		db	$90,$90,$90,$B8,$B9,$BA,$90,$A6,$A7,$A8,$90,$A9,$AA,$AB,$AC,$AD
		db	$AE,$AF,$90,$A8,$B0,$B1,$B2,$B3,$AE,$AB,$B4,$90,$B8,$B9,$BB,$90
		db	$90,$90,$90,$BC,$BD,$BE,$90,$90,$90,$90,$90,$90,$90,$90,$90,$90
		db	$90,$90,$90,$90,$90,$90,$90,$90,$90,$90,$90,$90,$BC,$BD,$BF,$90
sizeTITLE_STR	equ	*-TITLE_STR

;;;		db	$90,$99,$9A	; space,"Ch","A-C,F,P-W"
KEYTBL:
		db	$92,$93,$94,$95,$96,$97,$98,$92,$93,$94,$95,$96,$97
		db	$98,$92,$93,$94,$95,$96,$97,$98,$92,$93,$94,$95,$96,$97,$98,$90
		db	$90,$90,$90,$91,$91,$91,$91,$91,$91,$91,$91,$91,$91,$91,$91,$91
		db	$91,$91,$91,$91,$91,$91,$91,$91,$91,$91,$91,$91,$91,$91,$91,$90
sizeKEYTBL	equ	*-KEYTBL

PALTBL:
		incbin	"ppmck/vk/vkpal.bin"
sizePALTBL	equ	*-PALTBL
CHRTBL:
		incbin	"ppmck/vk/vkchr.bin"

